/* -*- mode: text; indent-tabs-mode: nil; -*- */
/* quiz.js */
/* Mike Wilson, cmikewilsonAgmailDcom */
/* June 10, 2005 - March 31, 2006 */

/* Anyone may copy and/or modify this software without restriction. */

var SectionsF = [];
var KnownF = [];

var SelectedSections = [];

var OrigWords;
var Words = [];
var Word;

var romajiCorrect;

function createFilters (words) {
    for (var i in words) {
        var word = words[i];
        var sectionId = wordSection(word);
        if (! SectionsF[sectionId])
            SectionsF[sectionId] = [];
        setAdd(SectionsF[sectionId], word);
    }
    return;
}

function filterWords (wordlist, sections) {
    var words = [];
    for (var s in sections) {
        var sectionId = sections[s];
        words = setUnion(words, SectionsF[sectionId]);
    }
    var unknown = setSubtract(words, KnownF);
    return unknown;
}

function compareRomajiAnswer () {
    /* Compute the correct answer and compare it with yours. */
    var answers = wordRomaji(Word);
    var entered = document.getElementById("rInput").value;
    var msg;
    var tdr = document.getElementById("rResult");
    var result = "incorrect";
    for (var i in answers) {
        answer = answers[i];
        if (answer.toLowerCase() == entered.toLowerCase())
            result = "correct";
    }
    if (result == "correct") {
        msg = "Correct: " + wordKana(Word);
        tdr.className = "correct";
        romajiCorrect = true;
    }
    else {
        msg = "Incorrect: " + wordKana(Word);
        tdr.className = "incorrect";
        romajiCorrect = false;
    }
    tdr.appendChild(document.createTextNode(msg));
    var eInput = document.getElementById("eInput");
    eInput.select();
    eInput.focus();
    return;
}

function compareEnglishAnswer () {
    /* Compute the correct answer and compare it with yours. */
    var answers = wordEnglish(Word);
    var entered = (document.getElementById("eInput").value);
    var msg;
    var tdr = document.getElementById("eResult");
    var result = "incorrect";
    for (var i in answers) {
        answer = answers[i];
        if (answer.toLowerCase() == entered.toLowerCase())
            result = "correct";
    }
    if (result == "correct") {
        msg = "Correct: " + wordEnglish(Word)[0];
        tdr.className = "correct";
        var englishCorrect = true;
    }
    else {
        msg = "Incorrect: " + wordEnglish(Word)[0];
        tdr.className = "incorrect";
        var englishCorrect = false;
    }
    tdr.appendChild(document.createTextNode(msg));
    if (romajiCorrect && englishCorrect)
        setAdd(KnownF,Word);
    askWord();
    return;
}

function askWord () {
    /* remove ID from previous TD; pick next word; add to table */
    /* ID must be unique, so it must be removed from the last TD
       before it can be included in the new TD.
       Also remove onKeypress action from old INPUT.
    */
    var rInput = document.getElementById("rInput")
    if (rInput) {
        rInput.removeAttribute("onKeypress");
        rInput.removeAttribute("id");
    }
    var rResult = document.getElementById("rResult");
    if (rResult)
        rResult.removeAttribute("id");
    var eInput = document.getElementById("eInput");
    if (eInput) {
        eInput.removeAttribute("onKeypress");
        eInput.removeAttribute("id");
    }
    var eResult = document.getElementById("eResult");
    if (eResult)
        eResult.removeAttribute("id");
    if (Words.length == 0) {
        /*deleteAllTableRows("table");*/   /* do I like this? -- no. */
        Words = randomize(filterWords(OrigWords,SelectedSections));
    }
    if (Words.length > 0) {
        Word = Words.pop();
        addGuessRow(Word);
        if (window.scrollBy)    /* scroll down -- not standard */
            window.scrollBy(0,100);
        var rInput = document.getElementById("rInput");
        rInput.select();
        rInput.focus();
    }
    else {
        var table = document.getElementById("table");
        var tr = table.insertRow(-1);
        var td = tr.insertCell(-1);
        td.className = "bold";
        td.setAttribute("colspan", "5");
        td.appendChild(document.createTextNode("No more words"));
        if (window.scrollBy)    /* scroll down -- not standard */
            window.scrollBy(0,100);
    }
    return;
}

function deleteAllTableRows (id) {
    var table = document.getElementById(id);
    while (table.rows.length != 0) 
        table.deleteRow(-1);
    return;
}

function addGuessRow (word) {
    var table = document.getElementById("table");
    var tr = table.insertRow(-1);
    var th = tr.insertCell(-1);    /* This isn't really a TH */
    th.className = "ref";
    var txt = wordFull(word);
    th.appendChild(document.createTextNode(txt));
    /* the RINPUT field */
    var tdri = tr.insertCell(-1);
    tdri.appendChild(document.createTextNode("romaji:"));
    var rInput = document.createElement("input");
    rInput.id = "rInput";
    /* avoid NS_ERROR_XPC_JS_THREW_STRING autocomplete bug */
    rInput.setAttribute("autocomplete", "off");
    rInput.setAttribute("type", "text");
    rInput.setAttribute("size", "20");
    rInput.onkeypress = checkRKeypress;
    tdri.appendChild(rInput);
    /* The rResult field, where we write "Correct", etc. */
    var tdrr = tr.insertCell(-1);
    tdrr.id = "rResult";
    /* EINPUT field */
    var tdei = tr.insertCell(-1);
    tdei.appendChild(document.createTextNode("english:"));
    var eInput = document.createElement("input");
    eInput.id = "eInput";
    /* avoid NS_ERROR_XPC_JS_THREW_STRING autocomplete bug */
    eInput.setAttribute("autocomplete", "off");
    eInput.setAttribute("type", "text");
    eInput.setAttribute("size", "20");
    eInput.onkeypress = checkEKeypress;
    tdei.appendChild(eInput);
    /* The eResult field, where we write "Correct", etc. */
    var tder = tr.insertCell(-1);
    tder.id = "eResult";
    return;
}

function dumpRow (word) {
    var table = document.getElementById("table");
    var tr = table.insertRow(-1);
    var tdFull = tr.insertCell(-1);
    tdFull.appendChild(document.createTextNode(wordFull(word)));
    var tdKana = tr.insertCell(-1);
    tdKana.appendChild(document.createTextNode(wordKana(word)));
    var tdRomaji = tr.insertCell(-1);
    tdRomaji.appendChild(document.createTextNode(wordRomaji(word)[0]));
    var tdEnglish = tr.insertCell(-1);
    tdEnglish.appendChild(document.createTextNode(wordEnglish(word)[0]));
//    var tdSection = tr.insertCell(-1);
//    tdSection.appendChild(document.createTextNode(sectionName(wordSection(word))));
//    var tdSource = tr.insertCell(-1);
//    tdSource.appendChild(document.createTextNode(wordSource(word)));
    return;
}

function fillControl (wordsources) {
    var control = document.getElementById("control");
    for (var i in wordsources) {
        var tr = control.insertRow(-1);
        var sourceName = wordsources[i][0];
        var sourceId = lookupSource(sourceName);
        var sections = wordsources[i].slice(1);
        var td = tr.insertCell(-1);
        td.setAttribute("colspan", "16");
        td.appendChild(document.createTextNode(sourceName));
        var tr = control.insertRow(-1);
        for (var j in sections) {
            var sectionName = sections[j][0];
            var sectionId = lookupSection(sectionName);
            var td = tr.insertCell(-1);
            var box = document.createElement("input");
            box.id = sectionId;
            box.setAttribute("type","checkbox");
            var ch = "chSection(this,"+sectionId+")";
            box.setAttribute("onChange",ch);
            box.checked = true;
            td.appendChild(box);
            td.appendChild(document.createTextNode(sectionName));
        }
        /* All button */
        var td = tr.insertCell(-1);
        var buttonAll = document.createElement("input");
        buttonAll.className = "button";
        buttonAll.setAttribute("type","button");
        buttonAll.setAttribute("onClick","chSectionButton("+sourceId+",0)");
        buttonAll.value = "All";
        td.appendChild(buttonAll);

        /* None button */
        var td = tr.insertCell(-1);
        var buttonNone = document.createElement("input");
        buttonNone.className = "button";
        buttonNone.setAttribute("type","button");
        buttonNone.setAttribute("onClick","chSectionButton("+sourceId+",1)");
        buttonNone.value = "None";
        td.appendChild(buttonNone);
    }
    return;
}

/*
 * Event Handlers
 */

function init () {
    /* Read word data and create a list of words */
    OrigWords = readWordSources(WordSources);
    /* Group words (indexes) by section */
    createFilters(OrigWords);
    /* Fill in the Control HTML Table */
    fillControl(WordSources);
    /* Start with all sections unselected */
    for (var ss in SourceSections) {
        var srcSecs = SourceSections[ss];
        var sections = srcSecs[1];
        for (var s in sections) {
            var sectionId = sections[s];
            setRemove(SelectedSections, sectionId);
            document.getElementById(sectionId).checked = false;
        }
    }
    return;
}

function guessWords () {
    deleteAllTableRows("table");
    Words = randomize(filterWords(OrigWords,SelectedSections));
    askWord();
    return;
}

function dumpWords () {
    deleteAllTableRows("table");
    Words = filterWords(OrigWords,SelectedSections);
    for (var i in Words)
        dumpRow(Words[i])
    return;
}

function checkRKeypress(event) {
    /* Check answer after ENTER keypress */
    if ((event) && (event.keyCode == 13))
        compareRomajiAnswer();
    else if ((window.event) && (window.event.keyCode == 13))
        compareRomajiAnswer();
    else
        /* ignore */;
    return;
}

function checkEKeypress(event) {
    /* Check answer after ENTER keypress */
    if ((event) && (event.keyCode == 13))
        compareEnglishAnswer();
    else if ((window.event) && (window.event.keyCode == 13))
        compareEnglishAnswer();
    else
        /* ignore */;
    return;
}

function clearKnown (event) {
    KnownF = [];
    return;
}

function chSection (el, sectionId) {
    if (el.checked)
        setAdd(SelectedSections, sectionId);
    else
        setRemove(SelectedSections, sectionId);
    return;
}

function chSectionButton (sourceId, an) {
    var sections = [];
    for (s in SourceSections) {
        var srcSecs = SourceSections[s];
        var src = srcSecs[0];
        if (src == sourceId) {
            sections = srcSecs[1];
            break;
        }
    }
    if (an == 0) /* all */
        for (var s in sections) {
            var sectionId = sections[s];
            setAdd(SelectedSections, sectionId);
            document.getElementById(sectionId).checked = true;
        }
    else if (an == 1) /* none */
        for (var s in sections) {
            var sectionId = sections[s];
            setRemove(SelectedSections, sectionId);
            document.getElementById(sectionId).checked = false;
        }
    return;
}
